
#include "p3d.h"

ssgBranch *wire_cube= NULL ;

ssgBranch *bbb_cube = NULL ;
ssgBranch *bbs_cube = NULL ;
ssgBranch *sss_cube = NULL ;


ssgTransform *makeGround ()
{
  ssgTransform *ground = new ssgTransform () ;

  sgVec4 *colour = new sgVec4 [ 1 ] ;
  sgVec3 *normal = new sgVec3 [ 1 ] ;
  sgVec2 *tcoord = new sgVec2 [ 4 ] ;
  sgVec3 *scoord = new sgVec3 [ 4 ] ;

  sgSetVec4 ( colour[0], 1, 1, 1, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 5, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 5, 5 ) ;
  sgSetVec2 ( tcoord [ 3 ], 0, 5 ) ;

  sgSetVec3 ( normal [ 0 ], 0, 0, 1 ) ;

  sgSetVec3 ( scoord [ 0 ], -60, -60, -5.6 ) ;
  sgSetVec3 ( scoord [ 1 ],  60, -60, -5.6 ) ;
  sgSetVec3 ( scoord [ 2 ],  60,  60, -5.6 ) ;
  sgSetVec3 ( scoord [ 3 ], -60,  60, -5.6 ) ;

  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_FAN,
                               4, scoord,
                               1, normal,
                               4, tcoord,
                               1, colour ) ;
  
  vt1 -> setState ( ground_gst ) ; ground -> addKid ( vt1 ) ;

  return ground ;
} ;

ssgTransform *makeBlueWireCube()
{
  ssgTransform *sel_cube = new ssgTransform () ;

  sgVec4 *colour = new sgVec4 [ 1 ] ;
  sgVec3 *normal = new sgVec3 [ 1 ] ;
  sgVec2 *tcoord = new sgVec2 [ 1 ] ;
  sgVec3 *scoord = new sgVec3 [ 8 ] ;

  sgSetVec4 ( colour[0], 0, 0, 1, 1 ) ;
  sgSetVec3 ( normal[0], 1, 0, 0 ) ;
  sgSetVec2 ( tcoord[0], 0, 0 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.5, -0.5, -0.5 ) ;
  sgSetVec3 ( scoord [ 1 ], -0.5, -0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 2 ],  0.5, -0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 3 ],  0.5, -0.5, -0.5 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.5,  0.5, -0.5 ) ;
  sgSetVec3 ( scoord [ 5 ], -0.5,  0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 6 ],  0.5,  0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 7 ],  0.5,  0.5, -0.5 ) ;

  unsigned short *sindex = new unsigned short [ 7 ] ;
  unsigned short *cindex = new unsigned short [ 1 ] ;
  unsigned short *nindex = new unsigned short [ 1 ] ;
  unsigned short *tindex = new unsigned short [ 1 ] ;

  sindex [ 0 ] = 0 ;
  sindex [ 1 ] = 1 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 7 ;
  sindex [ 5 ] = 3 ;
  sindex [ 6 ] = 2 ;
  
  cindex [ 0 ] = 0 ;
  nindex [ 0 ] = 0 ;
  tindex [ 0 ] = 0 ;

  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                7, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 5 ] ;
  
  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 0 ;
  sindex [ 2 ] = 4 ;
  sindex [ 3 ] = 5 ;
  sindex [ 4 ] = 1 ;

  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                5, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;

  sindex = new unsigned short [ 2 ] ;
  
  sindex [ 0 ] = 5 ;
  sindex [ 1 ] = 6 ;

  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                2, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;

  sindex = new unsigned short [ 2 ] ;
  
  sindex [ 0 ] = 4 ;
  sindex [ 1 ] = 7 ;

  ssgVTable *vt4 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                2, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;

  vt1 -> setState ( wire_gst ) ; sel_cube -> addKid ( vt1 ) ;
  vt2 -> setState ( wire_gst ) ; sel_cube -> addKid ( vt2 ) ;
  vt3 -> setState ( wire_gst ) ; sel_cube -> addKid ( vt3 ) ;
  vt4 -> setState ( wire_gst ) ; sel_cube -> addKid ( vt4 ) ;

  return sel_cube ;
}


void makeWireCube()
{
  wire_cube = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [ 1 ] ;
  sgVec3 *normal = new sgVec3 [ 1 ] ;
  sgVec2 *tcoord = new sgVec2 [ 1 ] ;
  sgVec3 *scoord = new sgVec3 [ 8 ] ;

  sgSetVec4 ( colour[0], 1.0, 1.0, 1.0, 0.5f ) ;
  sgSetVec3 ( normal[0], 1, 0, 0 ) ;
  sgSetVec2 ( tcoord[0], 0, 0 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.5, -0.5, -0.5 ) ;
  sgSetVec3 ( scoord [ 1 ], -0.5, -0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 2 ],  0.5, -0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 3 ],  0.5, -0.5, -0.5 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.5,  0.5, -0.5 ) ;
  sgSetVec3 ( scoord [ 5 ], -0.5,  0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 6 ],  0.5,  0.5,  0.5 ) ;
  sgSetVec3 ( scoord [ 7 ],  0.5,  0.5, -0.5 ) ;

  unsigned short *sindex = new unsigned short [ 7 ] ;
  unsigned short *cindex = new unsigned short [ 1 ] ;
  unsigned short *nindex = new unsigned short [ 1 ] ;
  unsigned short *tindex = new unsigned short [ 1 ] ;

  sindex [ 0 ] = 0 ;
  sindex [ 1 ] = 1 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 7 ;
  sindex [ 5 ] = 3 ;
  sindex [ 6 ] = 2 ;
  
  cindex [ 0 ] = 0 ;
  nindex [ 0 ] = 0 ;
  tindex [ 0 ] = 0 ;

  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                7, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 5 ] ;
  
  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 0 ;
  sindex [ 2 ] = 4 ;
  sindex [ 3 ] = 5 ;
  sindex [ 4 ] = 1 ;

  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                5, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;

  sindex = new unsigned short [ 2 ] ;
  
  sindex [ 0 ] = 5 ;
  sindex [ 1 ] = 6 ;

  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                2, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;

  sindex = new unsigned short [ 2 ] ;
  
  sindex [ 0 ] = 4 ;
  sindex [ 1 ] = 7 ;

  ssgVTable *vt4 =  new ssgVTable ( (GLenum) GL_LINE_STRIP,
                                2, sindex, scoord,
                                1, nindex, normal,
                                1, tindex, tcoord,
                                1, cindex, colour ) ;

  vt1 -> setState ( wire_gst ) ; wire_cube -> addKid ( vt1 ) ;
  vt2 -> setState ( wire_gst ) ; wire_cube -> addKid ( vt2 ) ;
  vt3 -> setState ( wire_gst ) ; wire_cube -> addKid ( vt3 ) ;
  vt4 -> setState ( wire_gst ) ; wire_cube -> addKid ( vt4 ) ;
}


#define S2 0.7071f
#define S3 0.5773f



ssgBranch *XZ_bend ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [  1 ] ;
  sgVec3 *normal = new sgVec3 [ 16 ] ;
  sgVec2 *tcoord = new sgVec2 [ 16 ] ;
  sgVec3 *scoord = new sgVec3 [ 16 ] ;

  sgSetVec4 ( colour[0], 1, 1, 0, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 1 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 1 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 1 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 1 ) ;

  sgSetVec2 ( tcoord [ 8 ], 0, 4 ) ;
  sgSetVec2 ( tcoord [ 9 ], 2, 4 ) ;
  sgSetVec2 ( tcoord [ 10], 4, 4 ) ;
  sgSetVec2 ( tcoord [ 11], 2, 4 ) ;

  sgSetVec2 ( tcoord [ 12], 0, 5 ) ;
  sgSetVec2 ( tcoord [ 13], 2, 5 ) ;
  sgSetVec2 ( tcoord [ 14], 4, 5 ) ;
  sgSetVec2 ( tcoord [ 15], 2, 5 ) ;

  sgSetVec3 ( normal [ 0 ], -S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 1 ],  S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 2 ],  S2, -S2, 0 ) ;
  sgSetVec3 ( normal [ 3 ], -S2, -S2, 0 ) ;

  sgSetVec3 ( normal [ 4 ], -S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 5 ],  S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 6 ],  S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 7 ], -S3, -S3, -S3 ) ;

  sgSetVec3 ( normal [ 8 ], -S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 9 ],  S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 10],  S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 11], -S3, -S3, -S3 ) ;

  sgSetVec3 ( normal [ 12],  0,  S2, -S2 ) ;
  sgSetVec3 ( normal [ 13],  0,  S2,  S2 ) ;
  sgSetVec3 ( normal [ 14],  0, -S2,  S2 ) ;
  sgSetVec3 ( normal [ 15],  0, -S2, -S2 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.1,  0.1,  0.5 ) ;
  sgSetVec3 ( scoord [ 1 ],  0.1,  0.1,  0.5 ) ;
  sgSetVec3 ( scoord [ 2 ],  0.1, -0.1,  0.5 ) ;
  sgSetVec3 ( scoord [ 3 ], -0.1, -0.1,  0.5 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.1,  0.1,  0.3 ) ;
  sgSetVec3 ( scoord [ 5 ],  0.1,  0.1,  0.3 ) ;
  sgSetVec3 ( scoord [ 6 ],  0.1, -0.1,  0.3 ) ;
  sgSetVec3 ( scoord [ 7 ], -0.1, -0.1,  0.3 ) ;

  sgSetVec3 ( scoord [ 8 ],  0.3,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 9 ],  0.3,  0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 10],  0.3, -0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 11],  0.3, -0.1, -0.1 ) ;

  sgSetVec3 ( scoord [ 12],  0.5,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 13],  0.5,  0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 14],  0.5, -0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 15],  0.5, -0.1, -0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 7  ;
  sindex [ 1 ] = 11 ;
  sindex [ 2 ] = 6  ;
  sindex [ 3 ] = 10 ;
  sindex [ 4 ] = 5  ;
  sindex [ 5 ] = 9  ;
  sindex [ 6 ] = 4  ;
  sindex [ 7 ] = 8  ;
  sindex [ 8 ] = 7  ;
  sindex [ 9 ] = 11 ;
  
  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 11;
  sindex [ 1 ] = 15;
  sindex [ 2 ] = 10;
  sindex [ 3 ] = 14;
  sindex [ 4 ] = 9 ;
  sindex [ 5 ] = 13;
  sindex [ 6 ] = 8 ;
  sindex [ 7 ] = 12;
  sindex [ 8 ] = 11;
  sindex [ 9 ] = 15;
  
  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;
  vt2 -> setState ( pipe_gst ) ; bend -> addKid ( vt2 ) ;
  vt3 -> setState ( pipe_gst ) ; bend -> addKid ( vt3 ) ;

  return bend ;
}


ssgBranch *end_XYZ ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [ 1 ] ;
  sgVec3 *normal = new sgVec3 [ 1 ] ;
  sgVec2 *tcoord = new sgVec2 [ 1 ] ;
  sgVec3 *scoord = new sgVec3 [ 24 ] ;

  sgSetVec4 ( colour[0], 0, 0, 0, 1 ) ;
  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec3 ( normal [ 0 ], 0, 1, 0 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.5, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 1 ], -0.5, -0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 2 ], -0.5,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 3 ], -0.5,  0.1,  0.1 ) ;

  sgSetVec3 ( scoord [ 4 ], 0.5,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 5 ], 0.5,  0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 6 ], 0.5, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 7 ], 0.5, -0.1,  0.1 ) ;

  sgSetVec3 ( scoord [ 8 ], -0.1, 0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 9 ], -0.1, 0.5,  0.1 ) ;
  sgSetVec3 ( scoord [10 ],  0.1, 0.5, -0.1 ) ;
  sgSetVec3 ( scoord [11 ],  0.1, 0.5,  0.1 ) ;

  sgSetVec3 ( scoord [12 ],  0.1, -0.5, -0.1 ) ;
  sgSetVec3 ( scoord [13 ],  0.1, -0.5,  0.1 ) ;
  sgSetVec3 ( scoord [14 ], -0.1, -0.5, -0.1 ) ;
  sgSetVec3 ( scoord [15 ], -0.1, -0.5,  0.1 ) ;

  sgSetVec3 ( scoord [16 ], -0.1, -0.1, -0.5 ) ;
  sgSetVec3 ( scoord [17 ], -0.1,  0.1, -0.5 ) ;
  sgSetVec3 ( scoord [18 ],  0.1, -0.1, -0.5 ) ;
  sgSetVec3 ( scoord [19 ],  0.1,  0.1, -0.5 ) ;

  sgSetVec3 ( scoord [20 ],  0.1, -0.1, 0.5 ) ;
  sgSetVec3 ( scoord [21 ],  0.1,  0.1, 0.5 ) ;
  sgSetVec3 ( scoord [22 ], -0.1, -0.1, 0.5 ) ;
  sgSetVec3 ( scoord [23 ], -0.1,  0.1, 0.5 ) ;

  unsigned short *nindex = new unsigned short [ 1 ] ;
  unsigned short *cindex = new unsigned short [ 1 ] ;
  unsigned short *tindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;
  nindex [ 0 ] = 0 ;
  tindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 4 ] ;

  sindex [ 0 ] = 0 ;
  sindex [ 1 ] = 1 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 3 ;

  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               4, sindex, scoord,
                               1, nindex, normal,
                               1, tindex, tcoord,
                               1, cindex, colour ) ;
  

  sindex = new unsigned short [ 4 ] ;

  sindex [ 0 ] = 4 ;
  sindex [ 1 ] = 5 ;
  sindex [ 2 ] = 6 ;
  sindex [ 3 ] = 7 ;

  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               4, sindex, scoord,
                               1, nindex, normal,
                               1, tindex, tcoord,
                               1, cindex, colour ) ;
  

  sindex = new unsigned short [ 4 ] ;

  sindex [ 0 ] = 8 ;
  sindex [ 1 ] = 9 ;
  sindex [ 2 ] = 10 ;
  sindex [ 3 ] = 11 ;

  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               4, sindex, scoord,
                               1, nindex, normal,
                               1, tindex, tcoord,
                               1, cindex, colour ) ;
  

  sindex = new unsigned short [ 4 ] ;

  sindex [ 0 ] = 12 ;
  sindex [ 1 ] = 13 ;
  sindex [ 2 ] = 14 ;
  sindex [ 3 ] = 15 ;

  ssgVTable *vt4 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               4, sindex, scoord,
                               1, nindex, normal,
                               1, tindex, tcoord,
                               1, cindex, colour ) ;
  

  sindex = new unsigned short [ 4 ] ;

  sindex [ 0 ] = 16 ;
  sindex [ 1 ] = 17 ;
  sindex [ 2 ] = 18 ;
  sindex [ 3 ] = 19 ;

  ssgVTable *vt5 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               4, sindex, scoord,
                               1, nindex, normal,
                               1, tindex, tcoord,
                               1, cindex, colour ) ;
  

  sindex = new unsigned short [ 4 ] ;

  sindex [ 0 ] = 20 ;
  sindex [ 1 ] = 21 ;
  sindex [ 2 ] = 22 ;
  sindex [ 3 ] = 23 ;

  ssgVTable *vt6 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               4, sindex, scoord,
                               1, nindex, normal,
                               1, tindex, tcoord,
                               1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;
  vt2 -> setState ( pipe_gst ) ; bend -> addKid ( vt2 ) ;
  vt3 -> setState ( pipe_gst ) ; bend -> addKid ( vt3 ) ;
  vt4 -> setState ( pipe_gst ) ; bend -> addKid ( vt4 ) ;
  vt5 -> setState ( pipe_gst ) ; bend -> addKid ( vt5 ) ;
  vt6 -> setState ( pipe_gst ) ; bend -> addKid ( vt6 ) ;

  return bend ;
}



ssgBranch *XX_straight ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [ 1 ] ;
  sgVec3 *normal = new sgVec3 [ 8 ] ;
  sgVec2 *tcoord = new sgVec2 [ 8 ] ;
  sgVec3 *scoord = new sgVec3 [ 8 ] ;

  sgSetVec4 ( colour[0], 1, 0, 0, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 3 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 3 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 3 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 3 ) ;

  sgSetVec3 ( normal [ 0 ], 0, -S2, -S2 ) ;
  sgSetVec3 ( normal [ 1 ], 0, -S2,  S2 ) ;
  sgSetVec3 ( normal [ 2 ], 0,  S2,  S2 ) ;
  sgSetVec3 ( normal [ 3 ], 0,  S2, -S2 ) ;

  sgSetVec3 ( normal [ 4 ], 0, -S2, -S3 ) ;
  sgSetVec3 ( normal [ 5 ], 0, -S2,  S3 ) ;
  sgSetVec3 ( normal [ 6 ], 0,  S2,  S3 ) ;
  sgSetVec3 ( normal [ 7 ], 0,  S2, -S3 ) ;

  sgSetVec3 ( scoord [ 0 ], 0.5, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 1 ], 0.5, -0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 2 ], 0.5,  0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 3 ], 0.5,  0.1, -0.1 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.5, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 5 ], -0.5, -0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 6 ], -0.5,  0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 7 ], -0.5,  0.1, -0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;

  return bend ;
}


ssgBranch *YY_straight ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [ 1 ] ;
  sgVec3 *normal = new sgVec3 [ 8 ] ;
  sgVec2 *tcoord = new sgVec2 [ 8 ] ;
  sgVec3 *scoord = new sgVec3 [ 8 ] ;

  sgSetVec4 ( colour[0], 1, 1, 1, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 3 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 3 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 3 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 3 ) ;

  sgSetVec3 ( normal [ 0 ], -S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 1 ], -S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 2 ],  S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 3 ],  S2, 0, -S2 ) ;

  sgSetVec3 ( normal [ 4 ], -S2, 0, -S3 ) ;
  sgSetVec3 ( normal [ 5 ], -S2, 0,  S3 ) ;
  sgSetVec3 ( normal [ 6 ],  S2, 0,  S3 ) ;
  sgSetVec3 ( normal [ 7 ],  S2, 0, -S3 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.1, -0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 1 ], -0.1, -0.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 2 ],  0.1, -0.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 3 ],  0.1, -0.5, -0.1 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.1, 0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 5 ], -0.1, 0.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 6 ],  0.1, 0.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 7 ],  0.1, 0.5, -0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;

  return bend ;
}


ssgBranch *ZZ_straight ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [ 1 ] ;
  sgVec3 *normal = new sgVec3 [ 8 ] ;
  sgVec2 *tcoord = new sgVec2 [ 8 ] ;
  sgVec3 *scoord = new sgVec3 [ 8 ] ;

  sgSetVec4 ( colour[0], 0, 1, 0, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 3 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 3 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 3 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 3 ) ;

  sgSetVec3 ( normal [ 0 ], -S2, -S2, 0 ) ;
  sgSetVec3 ( normal [ 1 ], -S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 2 ],  S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 3 ],  S2, -S2, 0 ) ;

  sgSetVec3 ( normal [ 4 ], -S2, -S3, 0 ) ;
  sgSetVec3 ( normal [ 5 ], -S2,  S3, 0 ) ;
  sgSetVec3 ( normal [ 6 ],  S2,  S3, 0 ) ;
  sgSetVec3 ( normal [ 7 ],  S2, -S3, 0 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.1, -0.1, 0.5 ) ;
  sgSetVec3 ( scoord [ 1 ], -0.1,  0.1, 0.5 ) ;
  sgSetVec3 ( scoord [ 2 ],  0.1,  0.1, 0.5 ) ;
  sgSetVec3 ( scoord [ 3 ],  0.1, -0.1, 0.5 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.1, -0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 5 ], -0.1,  0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 6 ],  0.1,  0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 7 ],  0.1, -0.1, -0.5 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;

  return bend ;
}



ssgBranch *XY2_bend ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [  1 ] ;
  sgVec3 *normal = new sgVec3 [ 16 ] ;
  sgVec2 *tcoord = new sgVec2 [ 16 ] ;
  sgVec3 *scoord = new sgVec3 [ 16 ] ;

  sgSetVec4 ( colour[0], 0, 0, 1, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 1 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 1 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 1 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 1 ) ;

  sgSetVec2 ( tcoord [ 8 ], 0, 4 ) ;
  sgSetVec2 ( tcoord [ 9 ], 2, 4 ) ;
  sgSetVec2 ( tcoord [ 10], 4, 4 ) ;
  sgSetVec2 ( tcoord [ 11], 2, 4 ) ;

  sgSetVec2 ( tcoord [ 12], 0, 5 ) ;
  sgSetVec2 ( tcoord [ 13], 2, 5 ) ;
  sgSetVec2 ( tcoord [ 14], 4, 5 ) ;
  sgSetVec2 ( tcoord [ 15], 2, 5 ) ;

  sgSetVec3 ( normal [ 0 ], 0,  S2, -S2 ) ;
  sgSetVec3 ( normal [ 1 ], 0, -S2, -S2 ) ;
  sgSetVec3 ( normal [ 2 ], 0, -S2,  S2 ) ;
  sgSetVec3 ( normal [ 3 ], 0,  S2,  S2 ) ;

  sgSetVec3 ( normal [ 4 ],  S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 5 ], -S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 6 ], -S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 7 ],  S3,  S3,  S3 ) ;

  sgSetVec3 ( normal [ 8 ], -S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 9 ],  S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 10],  S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 11], -S3, -S3,  S3 ) ;

  sgSetVec3 ( normal [ 12], -S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 13],  S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 14],  S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 15], -S2, 0,  S2 ) ;

  sgSetVec3 ( scoord [ 0 ],  0.5,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 1 ],  0.5, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 2 ],  0.5, -0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 3 ],  0.5,  0.1,  0.1 ) ;

  sgSetVec3 ( scoord [ 4 ],  0.3,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 5 ],  0.3, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 6 ],  0.3, -0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 7 ],  0.3,  0.1,  0.1 ) ;

  sgSetVec3 ( scoord [ 8 ], -0.1, -0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 9 ],  0.1, -0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 10],  0.1, -0.3,  0.1 ) ;
  sgSetVec3 ( scoord [ 11], -0.1, -0.3,  0.1 ) ;

  sgSetVec3 ( scoord [ 12], -0.1, -0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 13],  0.1, -0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 14],  0.1, -0.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 15], -0.1, -0.5,  0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 7  ;
  sindex [ 1 ] = 11 ;
  sindex [ 2 ] = 6  ;
  sindex [ 3 ] = 10 ;
  sindex [ 4 ] = 5  ;
  sindex [ 5 ] = 9  ;
  sindex [ 6 ] = 4  ;
  sindex [ 7 ] = 8  ;
  sindex [ 8 ] = 7  ;
  sindex [ 9 ] = 11 ;
  
  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 11;
  sindex [ 1 ] = 15;
  sindex [ 2 ] = 10;
  sindex [ 3 ] = 14;
  sindex [ 4 ] = 9 ;
  sindex [ 5 ] = 13;
  sindex [ 6 ] = 8 ;
  sindex [ 7 ] = 12;
  sindex [ 8 ] = 11;
  sindex [ 9 ] = 15;
  
  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;
  vt2 -> setState ( pipe_gst ) ; bend -> addKid ( vt2 ) ;
  vt3 -> setState ( pipe_gst ) ; bend -> addKid ( vt3 ) ;

  return bend ;
}


ssgBranch *XY_bend ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [  1 ] ;
  sgVec3 *normal = new sgVec3 [ 16 ] ;
  sgVec2 *tcoord = new sgVec2 [ 16 ] ;
  sgVec3 *scoord = new sgVec3 [ 16 ] ;

  sgSetVec4 ( colour[0], 0, 1, 1, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 1 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 1 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 1 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 1 ) ;

  sgSetVec2 ( tcoord [ 8 ], 0, 4 ) ;
  sgSetVec2 ( tcoord [ 9 ], 2, 4 ) ;
  sgSetVec2 ( tcoord [ 10], 4, 4 ) ;
  sgSetVec2 ( tcoord [ 11], 2, 4 ) ;

  sgSetVec2 ( tcoord [ 12], 0, 5 ) ;
  sgSetVec2 ( tcoord [ 13], 2, 5 ) ;
  sgSetVec2 ( tcoord [ 14], 4, 5 ) ;
  sgSetVec2 ( tcoord [ 15], 2, 5 ) ;

  sgSetVec3 ( normal [ 0 ], 0, -S2, -S2 ) ;
  sgSetVec3 ( normal [ 1 ], 0,  S2, -S2 ) ;
  sgSetVec3 ( normal [ 2 ], 0,  S2,  S2 ) ;
  sgSetVec3 ( normal [ 3 ], 0, -S2,  S2 ) ;

  sgSetVec3 ( normal [ 4 ], -S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 5 ],  S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 6 ],  S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 7 ], -S3, -S3,  S3 ) ;

  sgSetVec3 ( normal [ 8 ],  S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 9 ], -S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 10], -S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 11],  S3,  S3,  S3 ) ;

  sgSetVec3 ( normal [ 12],  S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 13], -S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 14], -S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 15],  S2, 0,  S2 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.5, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 1 ], -0.5,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 2 ], -0.5,  0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 3 ], -0.5, -0.1,  0.1 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.3, -0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 5 ], -0.3,  0.1, -0.1 ) ;
  sgSetVec3 ( scoord [ 6 ], -0.3,  0.1,  0.1 ) ;
  sgSetVec3 ( scoord [ 7 ], -0.3, -0.1,  0.1 ) ;

  sgSetVec3 ( scoord [ 8 ],  0.1,  0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 9 ], -0.1,  0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 10], -0.1,  0.3,  0.1 ) ;
  sgSetVec3 ( scoord [ 11],  0.1,  0.3,  0.1 ) ;

  sgSetVec3 ( scoord [ 12],  0.1,  0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 13], -0.1,  0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 14], -0.1,  0.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 15],  0.1,  0.5,  0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 7  ;
  sindex [ 1 ] = 11 ;
  sindex [ 2 ] = 6  ;
  sindex [ 3 ] = 10 ;
  sindex [ 4 ] = 5  ;
  sindex [ 5 ] = 9  ;
  sindex [ 6 ] = 4  ;
  sindex [ 7 ] = 8  ;
  sindex [ 8 ] = 7  ;
  sindex [ 9 ] = 11 ;
  
  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 11;
  sindex [ 1 ] = 15;
  sindex [ 2 ] = 10;
  sindex [ 3 ] = 14;
  sindex [ 4 ] = 9 ;
  sindex [ 5 ] = 13;
  sindex [ 6 ] = 8 ;
  sindex [ 7 ] = 12;
  sindex [ 8 ] = 11;
  sindex [ 9 ] = 15;
  
  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;
  vt2 -> setState ( pipe_gst ) ; bend -> addKid ( vt2 ) ;
  vt3 -> setState ( pipe_gst ) ; bend -> addKid ( vt3 ) ;

  return bend ;
}


ssgBranch *YZ_bend ()
{
  ssgBranch *bend = new ssgBranch () ;

  sgVec4 *colour = new sgVec4 [  1 ] ;
  sgVec3 *normal = new sgVec3 [ 16 ] ;
  sgVec2 *tcoord = new sgVec2 [ 16 ] ;
  sgVec3 *scoord = new sgVec3 [ 16 ] ;

  sgSetVec4 ( colour[0], 1, 0, 1, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 1 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 1 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 1 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 1 ) ;

  sgSetVec2 ( tcoord [ 8 ], 0, 4 ) ;
  sgSetVec2 ( tcoord [ 9 ], 2, 4 ) ;
  sgSetVec2 ( tcoord [ 10], 4, 4 ) ;
  sgSetVec2 ( tcoord [ 11], 2, 4 ) ;

  sgSetVec2 ( tcoord [ 12], 0, 5 ) ;
  sgSetVec2 ( tcoord [ 13], 2, 5 ) ;
  sgSetVec2 ( tcoord [ 14], 4, 5 ) ;
  sgSetVec2 ( tcoord [ 15], 2, 5 ) ;

  sgSetVec3 ( normal [ 0 ], -S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 1 ], -S2, -S2, 0 ) ;
  sgSetVec3 ( normal [ 2 ],  S2, -S2, 0 ) ;
  sgSetVec3 ( normal [ 3 ],  S2,  S2, 0 ) ;

  sgSetVec3 ( normal [ 4 ], -S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 5 ], -S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 6 ],  S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 7 ],  S3,  S3,  S3 ) ;

  sgSetVec3 ( normal [ 8 ], -S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 9 ], -S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 10],  S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 11],  S3, -S3,  S3 ) ;

  sgSetVec3 ( normal [ 12], -S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 13], -S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 14],  S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 15],  S2, 0,  S2 ) ;

  sgSetVec3 ( scoord [ 0 ], -0.1,  0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 1 ], -0.1, -0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 2 ],  0.1, -0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 3 ],  0.1,  0.1, -0.5 ) ;

  sgSetVec3 ( scoord [ 4 ], -0.1,  0.1, -0.3 ) ;
  sgSetVec3 ( scoord [ 5 ], -0.1, -0.1, -0.3 ) ;
  sgSetVec3 ( scoord [ 6 ],  0.1, -0.1, -0.3 ) ;
  sgSetVec3 ( scoord [ 7 ],  0.1,  0.1, -0.3 ) ;

  sgSetVec3 ( scoord [ 8 ], -0.1, -0.3,  0.1 ) ;
  sgSetVec3 ( scoord [ 9 ], -0.1, -0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 10],  0.1, -0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 11],  0.1, -0.3,  0.1 ) ;

  sgSetVec3 ( scoord [ 12], -0.1, -0.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 13], -0.1, -0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 14],  0.1, -0.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 15],  0.1, -0.5,  0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 7  ;
  sindex [ 1 ] = 11 ;
  sindex [ 2 ] = 6  ;
  sindex [ 3 ] = 10 ;
  sindex [ 4 ] = 5  ;
  sindex [ 5 ] = 9  ;
  sindex [ 6 ] = 4  ;
  sindex [ 7 ] = 8  ;
  sindex [ 8 ] = 7  ;
  sindex [ 9 ] = 11 ;
  
  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 11;
  sindex [ 1 ] = 15;
  sindex [ 2 ] = 10;
  sindex [ 3 ] = 14;
  sindex [ 4 ] = 9 ;
  sindex [ 5 ] = 13;
  sindex [ 6 ] = 8 ;
  sindex [ 7 ] = 12;
  sindex [ 8 ] = 11;
  sindex [ 9 ] = 15;
  
  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; bend -> addKid ( vt1 ) ;
  vt2 -> setState ( pipe_gst ) ; bend -> addKid ( vt2 ) ;
  vt3 -> setState ( pipe_gst ) ; bend -> addKid ( vt3 ) ;

  return bend ;
}


void makeBBBCube ()
{
  bbb_cube = new ssgBranch () ;
  bbb_cube -> addKid ( XZ_bend () ) ;
  bbb_cube -> addKid ( XY_bend () ) ;
  bbb_cube -> addKid ( YZ_bend () ) ;
  bbb_cube -> addKid ( end_XYZ () ) ;
}


void makeBBSCube ()
{
  bbs_cube = new ssgBranch () ;
  bbs_cube -> addKid ( XY_bend () ) ;
  bbs_cube -> addKid ( XY2_bend () ) ;
  bbs_cube -> addKid ( ZZ_straight () ) ;
  bbs_cube -> addKid ( end_XYZ () ) ;
}

void makeSSSCube ()
{
  sss_cube = new ssgBranch () ;
  sss_cube -> addKid ( XX_straight () ) ;
  sss_cube -> addKid ( YY_straight () ) ;
  sss_cube -> addKid ( ZZ_straight () ) ;
  sss_cube -> addKid ( end_XYZ () ) ;
}



Cell::Cell ( int x, int y, int z, int size )
{
  if ( wire_cube== NULL ) makeWireCube() ;
  if ( bbb_cube == NULL ) makeBBBCube () ;
  if ( bbs_cube == NULL ) makeBBSCube () ;
  if ( sss_cube == NULL ) makeSSSCube () ;

  sgSetCoord ( &c, (float)x - (float) size / 2.0f + 0.5f,
		   (float)y - (float) size / 2.0f + 0.5f,
		   (float)z - (float) size / 2.0f + 0.5f, 0,0,0 ) ;

  rot = 0 ;
  posn = new ssgTransform ( & c ) ;
  cell = new ssgSelector  () ;

  posn -> addKid ( cell ) ;

  /* Don't change the order of these without changing the defines */

  cell -> addKid ( wire_cube ) ;
  cell -> addKid (  bbb_cube ) ;
  cell -> addKid (  bbs_cube ) ;
  cell -> addKid (  sss_cube ) ;

  what = WIRE_CELL ;
  cell -> selectStep ( what ) ;
}


#define U PUZZ_UP
#define D PUZZ_DOWN
#define I PUZZ_IN
#define O PUZZ_OUT
#define L PUZZ_LEFT
#define R PUZZ_RIGHT

static int bbb_lut [ 4 ][ 6 ] =
{
  /* U  D  L  R  I  O */
  {  O, R, U, I, D, L },
  {  R, I, D, O, L, U },
  {  I, L, O, U, R, D },
  {  L, O, I, D, U, R }
} ;


static int bbs_lut [ 6 ][ 6 ] =
{
  /* U  D  L  R  I  O */
  {  U, D, O, I, R, L },
  {  U, D, I, O, L, R },
  {  I, O, L, R, U, D },
  {  O, I, L, R, D, U },
  {  R, L, D, U, I, O },
  {  L, R, U, D, I, O }
} ;

int Cell::flow ( int from )
{
  switch ( what )
  {
    case SSS_CELL :
      return from ;

    case BBS_CELL :
      if ( rot < 0 ) rot = 5 ;
      if ( rot > 5 ) rot = 0 ;

      return bbs_lut [ rot ][ from ] ;

    case BBB_CELL :
      if ( rot < 0 ) rot = 3 ;
      if ( rot > 3 ) rot = 0 ;

      return bbb_lut [ rot ][ from ] ;
  }

  return -1 ;
}


void Cell::rerot ()
{
  switch ( what )
  {
    case SSS_CELL :
    case BBS_CELL :
      if ( rot < 0 ) rot = 5 ;
      if ( rot > 5 ) rot = 0 ;

      switch ( rot )
      {
	case 0 : sgSetVec3 ( c.hpr,  0,  0,  0 ) ; break ;
	case 1 : sgSetVec3 ( c.hpr, 90,  0,  0 ) ; break ;
	case 2 : sgSetVec3 ( c.hpr, 90, 90,  0 ) ; break ;
	case 3 : sgSetVec3 ( c.hpr,-90, 90,  0 ) ; break ;
	case 4 : sgSetVec3 ( c.hpr,  0, 90,  0 ) ; break ;
	case 5 : sgSetVec3 ( c.hpr,-90, 90,-90 ) ; break ;
      }
      break ;

    case BBB_CELL :
      if ( rot < 0 ) rot = 3 ;
      if ( rot > 3 ) rot = 0 ;

      switch ( rot )
      {
	case 0 : sgSetVec3 ( c.hpr,  0,  0,  0 ) ; break ;
	case 1 : sgSetVec3 ( c.hpr, 90,  0,  0 ) ; break ;
	case 2 : sgSetVec3 ( c.hpr,180,  0,  0 ) ; break ;
	case 3 : sgSetVec3 ( c.hpr,270,  0,  0 ) ; break ;
      }
      break ;

    default :
      rot = 0 ;
      sgSetVec3 ( c.hpr,  0,  0,  0 ) ;
      break ;
  }

  posn -> setTransform ( &c ) ;
}


