
#define GRAVITY      -9.8
#define MAX_DROPLETS  4000

/* Average speed at the faucet */

#define PRESSURE      6.0

/* Some randomness is needed in the speed of droplets at the faucet */

#define SIDE_RANDOM   1.4
#define VERT_RANDOM   10.0

class Droplet ;

class Hose
{
  sgVec3     speed ;
  sgVec3     posn  ;
  ssgVTable *water ;
  Droplet   *drop [ MAX_DROPLETS ] ;
  sgVec3    outlet ;

  int total_score ;
  int total_flow  ;

public:

  Hose () ;

  void       update   () ;
  ssgVTable *getSSG   () { return water ; }
  float     *getSpeed () { return speed ; }
  float     *getPosn  () { return posn  ; }

  void setOutlet ( sgVec3 out ) ;
  void setSpeed ( sgVec3 sp ) { sgCopyVec3 ( speed, sp ) ; }
  void setPosn  ( sgVec3 po ) { sgCopyVec3 ( posn , po ) ; }

  void reset_score () { total_score = 0 ; }
  int  getScore    () { return total_score ; }
  int  getFlow     () { return total_flow  ; }
  void score       ( sgVec3 pos ) ;
} ;


class Droplet
{
  float   *posn ;
  sgVec3  speed ;
  Hose    *hose ;
  float z_reset ;
public:

  Droplet ( Hose *h, float *pos, float reset_height ) ;

  void setResetHeight ( float h ) { z_reset = h ; }

  void reset () ;

  void update ( float dt )
  {
    sgAddScaledVec3 ( posn, speed, dt ) ;
    speed [ 2 ] += GRAVITY * dt ;

    if ( posn[2] < z_reset )
    {
      hose -> score ( posn ) ;
      reset () ;
    }
  }
} ;


