
#include "p3d.h"


#define S2 0.7071f
#define S3 0.5773f


static ssgTransform *inlet  = NULL ;
static ssgTransform *outlet = NULL ;

ssgTransform *makeSpout ()
{
  ssgTransform *spout = new ssgTransform () ;

  sgVec4 *colour = new sgVec4 [  1 ] ;
  sgVec3 *normal = new sgVec3 [ 16 ] ;
  sgVec2 *tcoord = new sgVec2 [ 16 ] ;
  sgVec3 *scoord = new sgVec3 [ 16 ] ;

  sgSetVec4 ( colour[0], 0.7, 0.5, 0.2, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 1 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 1 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 1 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 1 ) ;

  sgSetVec2 ( tcoord [ 8 ], 0, 4 ) ;
  sgSetVec2 ( tcoord [ 9 ], 2, 4 ) ;
  sgSetVec2 ( tcoord [ 10], 4, 4 ) ;
  sgSetVec2 ( tcoord [ 11], 2, 4 ) ;

  sgSetVec2 ( tcoord [ 12], 0, 100 ) ;
  sgSetVec2 ( tcoord [ 13], 2, 100 ) ;
  sgSetVec2 ( tcoord [ 14], 4, 100 ) ;
  sgSetVec2 ( tcoord [ 15], 2, 100 ) ;

  sgSetVec3 ( normal [ 0 ],  S2, -S2, 0 ) ;
  sgSetVec3 ( normal [ 1 ],  S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 2 ], -S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 3 ], -S2, -S2, 0 ) ;

  sgSetVec3 ( normal [ 4 ],  S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 5 ],  S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 6 ], -S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 7 ], -S3, -S3,  S3 ) ;

  sgSetVec3 ( normal [ 8 ],  S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 9 ],  S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 10], -S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 11], -S3,  S3,  S3 ) ;

  sgSetVec3 ( normal [ 12],  S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 13],  S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 14], -S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 15], -S2, 0,  S2 ) ;

  sgSetVec3 ( scoord [ 0 ],  0.1, -0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 1 ],  0.1,  0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 2 ], -0.1,  0.1, -0.5 ) ;
  sgSetVec3 ( scoord [ 3 ], -0.1, -0.1, -0.5 ) ;

  sgSetVec3 ( scoord [ 4 ],  0.1, -0.1, -0.3 ) ;
  sgSetVec3 ( scoord [ 5 ],  0.1,  0.1, -0.3 ) ;
  sgSetVec3 ( scoord [ 6 ], -0.1,  0.1, -0.3 ) ;
  sgSetVec3 ( scoord [ 7 ], -0.1, -0.1, -0.3 ) ;

  sgSetVec3 ( scoord [ 8 ],  0.1,  0.3,  0.1 ) ;
  sgSetVec3 ( scoord [ 9 ],  0.1,  0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 10], -0.1,  0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 11], -0.1,  0.3,  0.1 ) ;

  sgSetVec3 ( scoord [ 12],  0.1, 30.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 13],  0.1, 30.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 14], -0.1, 30.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 15], -0.1, 30.5,  0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 7  ;
  sindex [ 1 ] = 11 ;
  sindex [ 2 ] = 6  ;
  sindex [ 3 ] = 10 ;
  sindex [ 4 ] = 5  ;
  sindex [ 5 ] = 9  ;
  sindex [ 6 ] = 4  ;
  sindex [ 7 ] = 8  ;
  sindex [ 8 ] = 7  ;
  sindex [ 9 ] = 11 ;
  
  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 11;
  sindex [ 1 ] = 15;
  sindex [ 2 ] = 10;
  sindex [ 3 ] = 14;
  sindex [ 4 ] = 9 ;
  sindex [ 5 ] = 13;
  sindex [ 6 ] = 8 ;
  sindex [ 7 ] = 12;
  sindex [ 8 ] = 11;
  sindex [ 9 ] = 15;
  
  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; spout -> addKid ( vt1 ) ;
  vt2 -> setState ( pipe_gst ) ; spout -> addKid ( vt2 ) ;
  vt3 -> setState ( pipe_gst ) ; spout -> addKid ( vt3 ) ;

  return spout ;
}


ssgTransform *Inlet::getSSG () { return inlet ; }

Inlet::Inlet ()
{
  inlet = makeSpout () ;
}


void Inlet::put ( sgVec3 pos )
{
  sgCoord c ;
  sgSetVec3 ( c.hpr, 0, 0, 0 ) ;
  sgCopyVec3 ( c.xyz, pos ) ;
  inlet -> setTransform ( & c ) ;
}



ssgTransform *makeDownSpout ()
{
  ssgTransform *spout = new ssgTransform () ;

  sgVec4 *colour = new sgVec4 [  1 ] ;
  sgVec3 *normal = new sgVec3 [ 16 ] ;
  sgVec2 *tcoord = new sgVec2 [ 16 ] ;
  sgVec3 *scoord = new sgVec3 [ 16 ] ;

  sgSetVec4 ( colour[0], 0.7, 0.5, 0.2, 1 ) ;

  sgSetVec2 ( tcoord [ 0 ], 0, 0 ) ;
  sgSetVec2 ( tcoord [ 1 ], 2, 0 ) ;
  sgSetVec2 ( tcoord [ 2 ], 4, 0 ) ;
  sgSetVec2 ( tcoord [ 3 ], 2, 0 ) ;

  sgSetVec2 ( tcoord [ 4 ], 0, 1 ) ;
  sgSetVec2 ( tcoord [ 5 ], 2, 1 ) ;
  sgSetVec2 ( tcoord [ 6 ], 4, 1 ) ;
  sgSetVec2 ( tcoord [ 7 ], 2, 1 ) ;

  sgSetVec2 ( tcoord [ 8 ], 0, 4 ) ;
  sgSetVec2 ( tcoord [ 9 ], 2, 4 ) ;
  sgSetVec2 ( tcoord [ 10], 4, 4 ) ;
  sgSetVec2 ( tcoord [ 11], 2, 4 ) ;

  sgSetVec2 ( tcoord [ 12], 0, 100 ) ;
  sgSetVec2 ( tcoord [ 13], 2, 100 ) ;
  sgSetVec2 ( tcoord [ 14], 4, 100 ) ;
  sgSetVec2 ( tcoord [ 15], 2, 100 ) ;

  sgSetVec3 ( normal [ 0 ],  S2,  S2, 0 ) ;
  sgSetVec3 ( normal [ 1 ],  S2, -S2, 0 ) ;
  sgSetVec3 ( normal [ 2 ], -S2, -S2, 0 ) ;
  sgSetVec3 ( normal [ 3 ], -S2,  S2, 0 ) ;

  sgSetVec3 ( normal [ 4 ],  S3,  S3, -S3 ) ;
  sgSetVec3 ( normal [ 5 ],  S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 6 ], -S3, -S3,  S3 ) ;
  sgSetVec3 ( normal [ 7 ], -S3,  S3, -S3 ) ;

  sgSetVec3 ( normal [ 8 ],  S3, -S3, -S3 ) ;
  sgSetVec3 ( normal [ 9 ],  S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 10], -S3,  S3,  S3 ) ;
  sgSetVec3 ( normal [ 11], -S3, -S3, -S3 ) ;

  sgSetVec3 ( normal [ 12],  S2, 0, -S2 ) ;
  sgSetVec3 ( normal [ 13],  S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 14], -S2, 0,  S2 ) ;
  sgSetVec3 ( normal [ 15], -S2, 0, -S2 ) ;

  sgSetVec3 ( scoord [ 0 ],  0.1,  0.1,  0.5 ) ;
  sgSetVec3 ( scoord [ 1 ],  0.1, -0.1,  0.5 ) ;
  sgSetVec3 ( scoord [ 2 ], -0.1, -0.1,  0.5 ) ;
  sgSetVec3 ( scoord [ 3 ], -0.1,  0.1,  0.5 ) ;

  sgSetVec3 ( scoord [ 4 ],  0.1,  0.1,  0.3 ) ;
  sgSetVec3 ( scoord [ 5 ],  0.1, -0.1,  0.3 ) ;
  sgSetVec3 ( scoord [ 6 ], -0.1, -0.1,  0.3 ) ;
  sgSetVec3 ( scoord [ 7 ], -0.1,  0.1,  0.3 ) ;

  sgSetVec3 ( scoord [ 8 ],  0.1, -0.3, -0.1 ) ;
  sgSetVec3 ( scoord [ 9 ],  0.1, -0.3,  0.1 ) ;
  sgSetVec3 ( scoord [ 10], -0.1, -0.3,  0.1 ) ;
  sgSetVec3 ( scoord [ 11], -0.1, -0.3, -0.1 ) ;

  sgSetVec3 ( scoord [ 12],  0.1,-30.5, -0.1 ) ;
  sgSetVec3 ( scoord [ 13],  0.1,-30.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 14], -0.1,-30.5,  0.1 ) ;
  sgSetVec3 ( scoord [ 15], -0.1,-30.5, -0.1 ) ;

  unsigned short *cindex = new unsigned short [ 1 ] ;

  cindex [ 0 ] = 0 ;

  unsigned short *sindex = new unsigned short [ 10] ;

  sindex [ 0 ] = 3 ;
  sindex [ 1 ] = 7 ;
  sindex [ 2 ] = 2 ;
  sindex [ 3 ] = 6 ;
  sindex [ 4 ] = 1 ;
  sindex [ 5 ] = 5 ;
  sindex [ 6 ] = 0 ;
  sindex [ 7 ] = 4 ;
  sindex [ 8 ] = 3 ;
  sindex [ 9 ] = 7 ;
  
  ssgVTable *vt1 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 7  ;
  sindex [ 1 ] = 11 ;
  sindex [ 2 ] = 6  ;
  sindex [ 3 ] = 10 ;
  sindex [ 4 ] = 5  ;
  sindex [ 5 ] = 9  ;
  sindex [ 6 ] = 4  ;
  sindex [ 7 ] = 8  ;
  sindex [ 8 ] = 7  ;
  sindex [ 9 ] = 11 ;
  
  ssgVTable *vt2 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  sindex = new unsigned short [ 10] ;
  sindex [ 0 ] = 11;
  sindex [ 1 ] = 15;
  sindex [ 2 ] = 10;
  sindex [ 3 ] = 14;
  sindex [ 4 ] = 9 ;
  sindex [ 5 ] = 13;
  sindex [ 6 ] = 8 ;
  sindex [ 7 ] = 12;
  sindex [ 8 ] = 11;
  sindex [ 9 ] = 15;
  
  ssgVTable *vt3 =  new ssgVTable ( (GLenum) GL_TRIANGLE_STRIP,
                               10, sindex, scoord,
                               10, sindex, normal,
                               10, sindex, tcoord,
                                1, cindex, colour ) ;
  
  vt1 -> setState ( pipe_gst ) ; spout -> addKid ( vt1 ) ;
  vt2 -> setState ( pipe_gst ) ; spout -> addKid ( vt2 ) ;
  vt3 -> setState ( pipe_gst ) ; spout -> addKid ( vt3 ) ;

  return spout ;
}


ssgTransform *Outlet::getSSG () { return outlet ; }

Outlet::Outlet ()
{
  outlet = makeDownSpout () ;
}


void Outlet::put ( sgVec3 pos )
{
  sgCoord c ;
  sgSetVec3 ( c.hpr, 0, 0, 0 ) ;
  sgCopyVec3 ( c.xyz, pos ) ;
  outlet -> setTransform ( & c ) ;
}


