
#define MAX_GRID     10
#define MAX_PIPELINE  1

/* DON'T EVER, EVER, EVER CHANGE THESE!!!! */
#define PUZZ_UP    0
#define PUZZ_DOWN  1
#define PUZZ_LEFT  2
#define PUZZ_RIGHT 3
#define PUZZ_IN    4
#define PUZZ_OUT   5

extern void clamp ( int *p ) ;


class Pipeline
{
public:
  Pipeline () ;

  int prev [ 3 ] ;
  int next [ 3 ] ;

  int inlet_x ;
  int inlet_y ;
  Inlet *inlet ;

  int outlet_x ;
  int outlet_y ;
  Outlet *outlet ;

  int connected ;

  Hose *hose ;

  void placeInlet  () ;
  void placeOutlet () ;
  void putHose     ( int x, int y, int z, int dirn ) ;

  void moveOutlet ( int x, int y ) ;

  void moveInlet ( int x, int y )
  {
    inlet_x = x ;
    inlet_y = y ;
    placeInlet () ;
  }

} ;


class Puzzle 
{
  friend Pipeline ;

  sgCoord pos ;

  int sel  [ 3 ] ;

  ssgTransform *spin ;
  ssgTransform *selector ;
  ssgTransform *ground ;

  Cell *cell [ MAX_GRID ][ MAX_GRID ][ MAX_GRID ] ;

  Pipeline *pipeline [ MAX_PIPELINE ] ;

  void followHose  ( Pipeline *p, int x, int y, int z, int dirn ) ;
public:
   Puzzle () ;
  ~Puzzle () ;

  int isConnected ( int n = 0 ) { return pipeline[n] -> connected ; }

  int getScore () { return pipeline[0] -> hose -> getScore () ; }
  int getFlow  () { return pipeline[0] -> hose -> getFlow  () ; }

  void reset () ;
  void update () ;


  void cursor ( int x, int y, int z )
  {
    pipeline[0] -> next[0] = x ;
    pipeline[0] -> next[1] = y ;
    pipeline[0] -> next[2] = z ;
    clamp ( pipeline[0] -> next ) ;
  }

  void backup ()
  {
    if ( cell[sel[0]][sel[1]][sel[2]] -> get() != WIRE_CELL )
      put_empty () ;
    else
    {
      pipeline[0] -> next[0] = sel[0] ;
      pipeline[0] -> next[1] = sel[1] ;
      pipeline[0] -> next[2] = sel[2] ;
      sel[0] = pipeline[0] -> prev[0] ;
      sel[1] = pipeline[0] -> prev[1] ;
      sel[2] = pipeline[0] -> prev[2] ;
    }

    clamp ( sel ) ;
    clamp ( pipeline[0] -> next ) ;
    clamp ( pipeline[0] -> prev ) ;
  }

  void accept ()
  {
    sel[0] = pipeline[0] -> next[0] ;
    sel[1] = pipeline[0] -> next[1] ;
    sel[2] = pipeline[0] -> next[2] ;
  }

  void rotate_up   () { cell[sel[0]][sel[1]][sel[2]] -> rotate_up  () ; }
  void rotate_down () { cell[sel[0]][sel[1]][sel[2]] -> rotate_down() ; }

  void step_up    () { pos . xyz [ 1 ] += 0.5f ; spin->setTransform(&pos); }
  void step_down  () { pos . xyz [ 1 ] -= 0.5f ; spin->setTransform(&pos); }
  void spin_up    () { pos . hpr [ 2 ] += 5.0f ; spin->setTransform(&pos); }
  void spin_down  () { pos . hpr [ 2 ] -= 5.0f ; spin->setTransform(&pos); }
  void spin_left  () { pos . hpr [ 0 ] -= 5.0f ; spin->setTransform(&pos); }
  void spin_right () { pos . hpr [ 0 ] += 5.0f ; spin->setTransform(&pos); }

  void cursor_up    () { cursor(sel[0],sel[1],sel[2]+1) ; }
  void cursor_down  () { cursor(sel[0],sel[1],sel[2]-1) ; }
  void cursor_in    () { cursor(sel[0],sel[1]+1,sel[2]) ; }
  void cursor_out   () { cursor(sel[0],sel[1]-1,sel[2]) ; }
  void cursor_left  () { cursor(sel[0]-1,sel[1],sel[2]) ; }
  void cursor_right () { cursor(sel[0]+1,sel[1],sel[2]) ; }

  void put_empty(){ clamp(sel);cell[sel[0]][sel[1]][sel[2]]->set(WIRE_CELL) ; }
  void put_bbb () { clamp(sel);cell[sel[0]][sel[1]][sel[2]]->set(BBB_CELL) ; }
  void put_bbs () { clamp(sel);cell[sel[0]][sel[1]][sel[2]]->set(BBS_CELL) ; }
  void put_sss () { clamp(sel);cell[sel[0]][sel[1]][sel[2]]->set(SSS_CELL) ; }

  ssgTransform *getSSG () { return spin ; }
} ;


